'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
function concatFunctions(firstFnc, secondFnc) {
    return firstFnc
        ?
            secondFnc ? function () {
                var param = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    param[_i] = arguments[_i];
                }
                return firstFnc(secondFnc.apply(void 0, param));
            }
                : firstFnc
        :
            secondFnc ? secondFnc
                : this.nop;
}
exports.concatFunctions = concatFunctions;
/** create a sync chain **/
function now(value, err) {
    return {
        then: function (fnc) {
            if (err) {
                return now(undefined, err);
            } //skip til catch
            /* call and rewrap */
            try {
                return now(fnc(value));
            }
            catch (_err) {
                return now(undefined, _err);
            }
            ;
        },
        catch: function (fnc) {
            fnc(err);
            return now(undefined, undefined);
        },
        value: function () { if (err) {
            throw err;
        } ; return value; }
    };
}
exports.now = now;
function nop(param) { return param; }
exports.nop = nop;
